using FitConnect.Models.Api.Set;

namespace FitConnect.Builder;

public class ReplyChannelBuilder : IReplyChannelBuilderWithDeMail, IReplyChannelBuilderWithElster,
    IReplyChannelBuilderWithEMail, IReplyChannelBuilderWithFink {
    public DeMail? DeMail { get; set; }
    public Elster? Elster { get; set; }
    public EMail? EMail { get; set; }
    public Fink? Fink { get; set; }

    public IReplyChannelBuilderWithDeMail WithDeMail(DeMail value) {
        this.DeMail = value;
        return this;
    }

    public IReplyChannelBuilderWithElster WithElster(Elster value) {
        this.Elster = value;
        return this;
    }

    public IReplyChannelBuilderWithEMail WithEMail(EMail value) {
        this.EMail = value;
        return this;
    }

    public IReplyChannelBuilderWithFink WithFink(Fink value) {
        this.Fink = value;
        return this;
    }

    public ReplyChannel Build() => new ReplyChannel {
        DeMail = DeMail,
        Elster = Elster,
        Fink = Fink,
        EMail = EMail
    };
}
