using FitConnect.Models.v1.Api;

namespace FitConnect;

public class SecurityEventException : Exception {
    public SecurityEventException(Problems problem, Exception? innerException = null,
        string additionalInfo = "") : base(
        $"{problem.Title}: {problem.Detail} {(string.IsNullOrWhiteSpace(additionalInfo) ? "" : " - " + additionalInfo)}",
        innerException) {
        Title = problem.Title;
        Detail = problem.Detail;
    }

    public SecurityEventException(Problems[] problem, Exception? innerException = null) : base(
        $"{problem[0].Title}: {problem[0].Detail}", innerException) {
        Title = problem.Select(p => p.Title).Aggregate((a, b) => a + "\r\n" + b);
        Detail = problem.Select(p => p.Detail).Aggregate((a, b) => a + "\r\n" + b);
    }

    public SecurityEventException(string title, string detail, Exception? innerException = null) :
        base(
            $"{title}: {detail}", innerException) {
        Title = title;
        Detail = detail;
    }

    public string Title { get; }
    public string Detail { get; }
}
